<?php
/* 
    xe1.11.6.p8.2 버전 안내 (배포 : https://ddart.net/xe/xe)
	
	
	기능, 동작부분은 전혀 안건드리고 php 8.2 에서 바뀐 문법규칙들을 맞출 목적으로
	정말 최소한(?)의 수정만 가했고 왠만하면 적게 고치는 방향으로 수정했습니다.
	100% 전부 다 수정한게 아니라 자주 쓰고 눈에 보이는 경로만 오류없게끔 처리했습니다.
	
	아직 코어부분에 숨어있는 문법 오류들이 많이 남아 있을수도 있는데 
	이런 오류들을 쉽게 발견할수있도록 exception 처리메시지를 약간 더 친절하게 해뒀습니다.
	
	기존의 사용하던 확장기능들(모듈,애드온,스킨...)도 php8에서 큰 수정없이 사용할수 있도록
	템플릿 캐시파일 만들때 일부 처리가능하게끔은 해뒀는데 나머지는 수작업으로 문법오류들을 잡아줘야합니다.
	sketchbook5 처럼 자주 이용되는 모듈들은 눈에 보이는 문법오류를 선처리(90%정도)한 버전도 함께 배포사이트에 올려두었습니다.

*/


// 디버깅 도구 : 크롬 익스텐션 Chrome Logger 
// (https://chrome.google.com/webstore/detail/chrome-logger/noaneddfkdjfnfdakjjmocngnfkfehhd)
// 를 크롬에 설치하면 개발자도구 콘솔창에서 서버 로그메시지들을 곧바로 확인할수 있습니다.
// 아래는 크롬 로거에 사용되는 서버사이드 모듈인데 파일로깅이 가능하도록 제가 약간 수정을 가한 버전이고 
// 배포판에 함께 들어 있습니다.
require_once "ChromePhp.php";

// xe 캐시파일을 만드는 과정에서 오류가 나면 오류가 포함된 파일을 지울건지 유지할건지 선택.
// 이 부분 주석처리하면 템플릿 원본에서 나는 오류를 계속 볼수 있습니다.
define ('_SAVE_COMPILE_TARGET_', 1);

// 백그라운드 동작으로 인해 오류가 크롬 콘솔창에서 안잡힐땐 아래 주석을 풀어 파일로그를 이용해 잡으세요.
//ChromePhp::setLogFile("./ChromePhp.log");
 


/* Copyright (C) XEHub <https://www.xehub.io> */
/**
 * @file  index.php
 * @author XEHub (developers@xpressengine.com)
 * @brief Start page
 *
 * @mainpage XpressEngine
 * @section intro introduction
 *
 * "XpressEngine (XE)" is an opensource and being developed in the opensource project.\n
 * For more information, please see the link below.
 * - Official website: http://www.xpressengine.com
 * - Offcial Repository: https://github.com/xpressengine/xe-core
 * \n
 * "XpressEngine (XE)" is free software; you can redistribute it and/or \n
 * modify it under the terms of the GNU Lesser General Public \n
 * License as published by the Free Software Foundation; either \n
 * version 2.1 of the License, or (at your option) any later version. \n
 * \n
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * \n
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 **/

/**
 * @brief Declare constants for generic use and for checking to avoid a direct call from the Web
 **/
define('__XE__',   TRUE);
/**
 * @brief Include the necessary configuration files
 **/
require dirname(__FILE__) . '/config/config.inc.php';


/**
 * @brief Initialize by creating Context object
 * Set all Request Argument/Environment variables
 **/
$oContext = Context::getInstance();
$oContext->init();

/**
 * @brief If default_url is set and it is different from the current url, attempt to redirect for SSO authentication and then process the module
 **/
if($oContext->checkSSO())
{
	$oModuleHandler = new ModuleHandler();

	try
	{
		if($oModuleHandler->init())
		{
			$oModuleHandler->displayContent($oModuleHandler->procModule());
		}
	}
	catch(Exception $e)
	{
		htmlHeader();
		echo Context::getLang($e->getMessage());
		htmlFooter();
	}
	catch(Error $e)
	{
		htmlHeader();
		$msg = Array("<table cellpadding=5><col nowrap align=right width=150><col>");
		$msg[] = "<tr><td align=right>Name    </td><td>" . get_class($e)    . "</td></tr>";
		$msg[] = "<tr><td align=right>Message </td><td>" . $e->getMessage() . "</td></tr>";
		$msg[] = "<tr><td align=right>File    </td><td>" . $e->getFile()    . "</td></tr>";
		$msg[] = "<tr><td align=right>Line    </td><td>" . $e->getLine()    . "</td></tr>";
		$msg[] = "<tr><td align=right>Code    </td><td>" . $e->getCode()    . "</td></tr>";
		$msg[] = "</table>";
		echo implode(PHP_EOL, $msg);
		htmlFooter();
		ChromePhp::log($e);
	}
}

$oContext->close();

/* End of file index.php */
/* Location: ./index.php */
